dupload(1)

NAME
dupload - Debian package upload tool

SYNOPSIS
dupload [options...] [changes-file|directory...]

DESCRIPTION
dupload is a tool that enables people maintaining Debian packages to easily upload them to a Debian repository.

dupload checks each non-option argument to find readable files or directories. It parses the files as .changes files, or tries to find such files in the given directories.

dupload will warn if the name of the file does not end with .changes. Further processing is done changing into the directories of the changes files.

dupload tests the available checksums and size for each file listed in the .changes file, and fails if it finds a mismatch. If all this goes well, dupload checks if there is an .upload file with the basename of the .changes file. If the file to be uploaded is recorded to have already been uploaded to the specified host, it is skipped.

After the list of files to upload is finished, dupload tries to connect to the server and upload. Each successfully uploaded file is recorded in the .upload log file.

If all files of a package are processed, the .changes file is mailed to the announcement address specified in the configuration file, see the Announcement section for more details.

  Upload methods
The default transfer method is ftp. Alternative methods are http, https, scp/SSH, scpb/SSH, rsync/SSH and copy.

If you are using an upload queue, use ftp because it is fast. If you are using an authenticated host, always use https, or one of scp or rsync via SSH, because ftp transmits the password in clear text.

ftp If no login (username) is defined in the configuration file, anonymous is used. The password is derived from your login name and your hostname, which is common for anonymous FTP logins. For anonymous logins only, you can provide the "password" in the configuration file.

    For logins other than anonymous, you are asked for the password. For security reasons there is no way to supply it via the command-line or the environment.

http (since 2.9.9) / https (since 2.9.9)
    There is no default login nor password. If you specify a login, a password will be fetched from passwordcmd or if that is not defined via the Secret Service interface, otherwise it will be prompted.

scp (since 1.8) / scpb (since 1.17)
    The default login is delegated to SSH and its own configuration.

    The scp/SSH method only works properly if no password is required (see ssh(1)). When you use scp, it is recommended to set the "method" keyword to scpb, which will transfer all files in a batch.

rsync (since 2.4.1)
    The default login is delegated to SSH and its own configuration.

copy (since 2.9.0)
    The copy method works by simply copying the files to another directory in the local filesystem.

  Announcement
If the host has been configured to send announcement mails, the .changes file will be sent to the specified addresses.

The contents of all the following files are prepended to the announcement mail body, if present:

package.announce
package_upstream-version.announce
package_upstream-version-revision.announce

Where upstream-version and revision are to be replaced with actual version numbers. For example, if your package is called foobar, has upstream version 3.14, and Debian revision 2:

•   If you only want the announcement to be made with only ONE upload, you name it foobar_3.14-2.announce.

•   If you want it to be made with every upload of a particular upstream version, name it foobar_3.14.announce.

•   If you want it made with every upload of a given package, name it foobar.announce.

By default, the announcement addresses are unset because dinstall sends mails instead.

OPTIONS

-t, --to nickname
    Upload to nickname'd host. nickname is the key for doing lookups in the config file. You can use the default_host configuration option to specify a host without --to.

-c, --configfile filename
    Read the file filename as a configuration file, in addition to the global configuration file.

-f, --force
    Upload regardless of the transfers logged as already completed.

-k, --keep
    Keep going, skipping packages whose checksums does not match.

-q, --quiet
    Be quiet, i.e., suppress normal output and progress bars.

-d, --debug [level]
    Enable more verbose output from the ftp, scp and scpb methods.

    For scp and scpb (since 2.10.2) a -v per level is passed to the scp command.

--no
    Dry run, no files are changed, no upload is attempted, only tell what we would do.

--nostats
    Suppress printing download statistics.

    Since version 2.10.2.

--mta pathname
    Use pathname as the sendmail compatible MTA. The MTA specified must support the -f option to set the envelope sender address, and the -F option to set the sender's full name. The default is /usr/sbin/sendmail.

    Since version 2.9.8.

--nomail
    Suppress announcement for this run. You can send it later by just calling dupload again w/o this option. Note that this option is by default implied for all hosts with the dinstall_runs option set to 1.

--mailonly
    Acts as if --no has been specified, but sends the announcements, unconditionally.

--noarchive
    Adds an X-No-Archive: yes header so that the announcement will not be archived. You can use the per-host archive option in the configuration file.

--skip-hooks hook[,...]
    Skip running the comma-separated list of hooks. The hook names can be the filename or the absolute pathname for the hook command, excluding any argument. This option can be specified multiple times.

    Since version 2.11.0.

-p, --print
    Print the "database" as read from the config files and exit. If a host is specified via option --to, only this host's entry is displayed.

--help
    Prints the program usage message and exits.

-V, --Version
    Prints version and exits.

FILES

/etc/dupload.conf
~/.dupload.conf
--configfile config-file
    The configuration files are loaded if available in the order listed, overriding previous files.

package.announce
package_upstream-version.announce
package_upstream-version-revision.announce
    If present, they will all be read to prepend to the announcement mail.

.changes
.dsc
.orig.tar.*
.debian.tar.*
.diff.*
.deb
    The .changes file to upload and all of its referenced files.

package_version_arch.upload
    The file where dupload writes the upload log.

ENVIRONMENT

DUPLOAD_SKIP_HOOKS
    A comma-separated list of hooks to skip running. The --skip-hooks option overrides this setting.

    Since version 2.11.0.

BUGS
dupload is tested on Debian systems only. It should not require too much effort to make it run under others systems, though.

SEE ALSO
dupload.conf(5)